import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * bone and remove them from the blood.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Dog extends Actor
{

    /**
     * Act: move up and down when cursor keys are pressed.
     */
    public Dog()
    {
        reSize();

    } 
    
    public void act() 
    {
        move(1);
        checkKeyPress();
        checkCollision();  
        
          if (isTouching(Bone.class))
        {
            removeTouching(Bone.class);
            getWorld().addObject(new Bone2(), 800, 800 + Greenfoot.getRandomNumber(100));
        }
    } 
    
    public void reSize()
    {
        GreenfootImage image = getImage();  
        //System.out.println("Width: "+image.getWidth()+"\nHeight: "+image.getHeight());
        image.scale(50, 50);
        setImage(image);
    }

    private void checkKeyPress()
    {
        if(Greenfoot.isKeyDown("up"))
        {
            setLocation(getX(), getY()-4);
        }
        
        if(Greenfoot.isKeyDown("down"))
        {
            setLocation(getX(), getY()+4);
        }
        
        if(Greenfoot.isKeyDown("left"))
        {
            setLocation(getX()-4, getY());
        }
        
          if(Greenfoot.isKeyDown("right"))
        {
            setLocation(getX()+4, getY());
        }
    } 
       
    private void checkCollision()
    {
        if(isTouching(Bone.class))
        {
            removeTouching(Bone.class);
            Greenfoot.playSound("crunch.wav");
            Field bloodstream = (Field)getWorld();
            bloodstream.addScore(20); // I must "cast" before I can call the method written in the World class.
            
        } 
        if(isTouching(Butterfly.class))
        {
            removeTouching(Butterfly.class);
            Field bloodstream = (Field)getWorld();
            bloodstream.addScore(-100);
        }
        
        if(isTouching(House.class))
        {
            removeTouching(House.class);
            Greenfoot.playSound("woof5.wav");
            Greenfoot.stop();

        }
        
    }
    
   
}

    
  
