import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The field is th e setting for our White Blood Cell scenario. 
 * It's a place where blood cells, bone and butterflyes float around.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Field extends World
{
    private int score; 
    private int time;

    public Field()
    {    
        super(780, 360, 1); 
        prepare();
        setPaintOrder(Cloud.class);
        score = 0;
        showScore();
        time = 2000; 
        showTime();
    }

    private void countTime()
    {
        time--;
        showTime();

        if(time == 0) 
        {
            showEndMessage();
            Greenfoot.stop();
        }
    }	

    private void showTime () 
    {
        showText("Time: " + time, 700, 20); 
    }

    /**
     * Show the end-of-game message on screen. 
     */
    private void showEndMessage()
    {
        showText("Time is up - you win!", 390, 150);
        showText("Your final score: " + score + "points", 390, 170); 
    }

    /** 
     * I have created an addScore method nd located it in the World class so that I can access this method from all of my Actor classes. 
     */
    public void addScore(int points)  
    {
        score = score + points;
        showScore(); 
    }

    private void showScore()
    {
        showText("Score:" + score, 80, 25); 
    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        if (Greenfoot.getRandomNumber(100)< 1) 
        {
            addObject(new Bone(), 779, Greenfoot.getRandomNumber(360));
        }

        if (Greenfoot.getRandomNumber(100)< 1) 
        {
            addObject(new Cloud(), 772, 0);
        }

        if (Greenfoot.getRandomNumber(100)< 1) 
        {
            addObject(new Butterfly(), 779, Greenfoot.getRandomNumber(360));
        }

        if(Greenfoot.getRandomNumber(100)<1)
        {
            addObject(new House(),779,Greenfoot.getRandomNumber(360));
        }   
        countTime(); 
    }

    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the lining at the edge of the blood stream.
     */
    private void prepare()
    {
        Dog dog = new Dog();
        addObject(dog, 150,179); 
        Raindrop raindrop = new Raindrop();
        addObject(raindrop,0,180);
        Raindrop raindrop2 = new Raindrop();
        addObject(raindrop2,770,180); 
        Cloud lining = new Cloud();
        addObject(lining,100,21);
        Cloud lining2 = new Cloud();
        addObject(lining2,252,21);
        Cloud lining3 = new Cloud();
        addObject(lining3,368,22);
        Cloud lining4 = new Cloud();
        addObject(lining4,503,26);
        Cloud lining5 = new Cloud();
        addObject(lining5,651,17);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(770,180);
        raindrop2.setLocation(605,199);
        raindrop2.setLocation(764,180);
        Cloud lining6 = new Cloud();
        addObject(lining6,132,350);
        Cloud lining7 = new Cloud();
        addObject(lining7,273,354);
        Cloud lining8 = new Cloud();
        addObject(lining8,385,355);
        Cloud lining9 = new Cloud();
        addObject(lining9,524,350);
        Cloud lining10 = new Cloud();
        addObject(lining10,655,354);
        lining4.setLocation(502,15);
        lining3.setLocation(369,11);
        lining3.setLocation(369,11);
        lining3.setLocation(369,11);
        lining3.setLocation(369,11);
        lining3.setLocation(369,11);
        lining3.setLocation(369,11);
        lining3.setLocation(369,11);
        Raindrop raindrop3 = new Raindrop();
        addObject(raindrop3,225,186);
        raindrop3.setLocation(96,87);
        lining2.setLocation(255,12);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(96,87);
        raindrop3.setLocation(155,83);
        removeObject(raindrop2);
        removeObject(raindrop);
        raindrop3.setLocation(178,83);
        removeObject(lining);
        removeObject(lining2);
        removeObject(lining3);
        removeObject(lining4);
        removeObject(lining5);
        removeObject(lining6);
        removeObject(lining8);
        removeObject(lining9);
        removeObject(lining10);
        removeObject(lining7);
        Butterfly butterfly = new Butterfly();
        addObject(butterfly,436,119);
        dog.setLocation(102,167);
        raindrop3.setLocation(241,145);
        butterfly.setLocation(492,163);
        butterfly.setLocation(487,167);
        butterfly.setLocation(333,186);
        butterfly.setLocation(357,142);
        raindrop3.setLocation(409,144);
        raindrop3.setLocation(287,115);
        butterfly.setLocation(335,164);
        butterfly.setLocation(399,156);
        raindrop3.setLocation(126,75);
        Raindrop raindrop4 = new Raindrop();
        addObject(raindrop4,201,73);
        Raindrop raindrop5 = new Raindrop();
        addObject(raindrop5,303,86);
        Raindrop raindrop6 = new Raindrop();
        addObject(raindrop6,430,92);
        Raindrop raindrop7 = new Raindrop();
        addObject(raindrop7,384,59);
        Raindrop raindrop8 = new Raindrop();
        addObject(raindrop8,575,90);
        Raindrop raindrop9 = new Raindrop();
        addObject(raindrop9,508,75);
        Raindrop raindrop10 = new Raindrop();
        addObject(raindrop10,705,83);
        Raindrop raindrop11 = new Raindrop();
        addObject(raindrop11,628,72);
        Raindrop raindrop12 = new Raindrop();
        addObject(raindrop12,71,65);
        Cloud cloud11 = new Cloud();
        addObject(cloud11,98,10);
        Cloud cloud12 = new Cloud();
        addObject(cloud12,267,20);
        Cloud cloud13 = new Cloud();
        addObject(cloud13,442,44);
        Cloud cloud14 = new Cloud();
        addObject(cloud14,534,26);
        Cloud cloud15 = new Cloud();
        addObject(cloud15,688,24);
        Cloud cloud16 = new Cloud();
        addObject(cloud16,15,32);
        cloud16.setLocation(21,47);
        cloud16.setLocation(18,33);
        cloud16.setLocation(9,29);
        cloud16.setLocation(12,21);
        cloud16.setLocation(41,51);
        cloud16.setLocation(35,52);
        cloud12.setLocation(257,36);
        cloud14.setLocation(536,19);
        cloud14.setLocation(540,9);
        cloud14.setLocation(601,41);
        cloud13.setLocation(439,51);
        cloud15.setLocation(703,30);
        cloud13.setLocation(484,49);
        removeObject(butterfly);
        cloud16.setLocation(37,53);
        cloud16.setLocation(39,49);
        cloud16.setLocation(39,50);
        removeObject(cloud13);
        Cloud cloud17 = new Cloud();
        addObject(cloud17,453,50);
    }
}

